libxml++ 5.0.1

- Main Page
- Related Pages
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
xmlpp::DtdValidator Class Reference

XML DTD validator. More...

`#include <libxml++/validators/dtdvalidator.h>`

Inheritance diagram for xmlpp::DtdValidator:
[legend]

## Public Member Functions
LIBXMLPP_API | DtdValidator ()
LIBXMLPP_API | DtdValidator (const std::string& filename)
| Create a validator and parse an external subset (DTD file) immediately. More...
LIBXMLPP_API | DtdValidator (const ustring& external, const ustring& system)
| Create a validator and parse an external subset (DTD file) immediately. More...
LIBXMLPP_API | DtdValidator (Dtd* dtd, bool take_ownership)
| Create a validator. More...
LIBXMLPP_API | ~DtdValidator () override
LIBXMLPP_API Dtd* | get_dtd () noexcept
| Get the parsed DTD. More...
LIBXMLPP_API const Dtd* | get_dtd () const noexcept
| Get the parsed DTD. More...
LIBXMLPP_API | operator bool () const noexcept override
| Test whether a DTD has been parsed. More...
LIBXMLPP_API void | parse_file (const std::string& filename) override
| Parse an external subset (DTD file). More...
LIBXMLPP_API void | parse_memory (const ustring& contents) override
| Parse a DTD from a string. More...
LIBXMLPP_API void | parse_stream (std::istream& in)
| Parse a DTD from a stream. More...
LIBXMLPP_API void | parse_subset (const ustring& external, const ustring& system)
| Parse an external subset (DTD file). More...
LIBXMLPP_API void | set_dtd (Dtd* dtd, bool take_ownership)
| Set a DTD. More...
LIBXMLPP_API void | validate (const Document* document) override
| Validate a document, using a previously parsed DTD. More...
Public Member Functions inherited from xmlpp::Validator
LIBXMLPP_API | Validator () noexcept
LIBXMLPP_API | ~Validator () override

## Protected Member Functions
LIBXMLPP_API void | initialize_context () override
LIBXMLPP_API void | release_underlying () override
Protected Member Functions inherited from xmlpp::Validator
virtual LIBXMLPP_API void | check_for_exception ()
virtual LIBXMLPP_API void | check_for_validity_messages ()
virtual LIBXMLPP_API void | handle_exception ()
| To be called in an exception handler. More...
virtual LIBXMLPP_API void | on_validity_error (const ustring& message)
virtual LIBXMLPP_API void | on_validity_warning (const ustring& message)
Protected Member Functions inherited from xmlpp::NonCopyable
| NonCopyable () noexcept
| NonCopyable (const NonCopyable&)=delete
| NonCopyable (NonCopyable&&)=delete
virtual | ~NonCopyable ()
NonCopyable& | operator= (const NonCopyable&)=delete
NonCopyable& | operator= (NonCopyable&&)=delete

## Additional Inherited Members
Static Protected Member Functions inherited from xmlpp::Validator
static LIBXMLPP_API void | callback_validity_error (void* ctx, const char* msg,...)
static LIBXMLPP_API void | callback_validity_warning (void* ctx, const char* msg,...)
Protected Attributes inherited from xmlpp::Validator
std::unique_ptr< exception > | exception_
ustring | validate_error_
ustring | validate_warning_

## Detailed Description

XML DTD validator.

DTD = Document Type Definition

## Constructor & Destructor Documentation

LIBXMLPP_API xmlpp::DtdValidator::DtdValidator | ( |  | ) |

LIBXMLPP_API xmlpp::DtdValidator::DtdValidator | ( | const std::string & | filename | ) |
| explicit

Create a validator and parse an external subset (DTD file) immediately.

Parameters

  filename | The URL of the DTD.

Exceptions

  xmlpp::parse_error |

LIBXMLPP_API xmlpp::DtdValidator::DtdValidator | ( | const ustring& | external,
|  | const ustring& | system
| ) |  |
| explicit

Create a validator and parse an external subset (DTD file) immediately.

Parameters

  external | The external ID of the DTD.
  system | The URL of the DTD.

Exceptions

  xmlpp::parse_error |

LIBXMLPP_API xmlpp::DtdValidator::DtdValidator | ( | Dtd* | dtd,
|  | bool | take_ownership
| ) |  |
| explicit

Create a validator.

Since libxml++ 3.0:

Parameters

  dtd | A pointer to the DTD to use when validating XML documents.
  take_ownership | If `true`, the validator takes ownership of the DTD. The caller must not delete it. If `false`, the validator does not take ownership of the DTD. The caller must guarantee that the DTD exists as long as the validator keeps a pointer to it. The caller is responsible for deleting the DTD when it's no longer needed.

LIBXMLPP_API xmlpp::DtdValidator::~DtdValidator | ( |  | ) |
| override

## Member Function Documentation

LIBXMLPP_API Dtd* xmlpp::DtdValidator::get_dtd | ( |  | ) |
| noexcept

Get the parsed DTD.

Returns
  A pointer to the parsed DTD, or `nullptr`.

LIBXMLPP_API const Dtd* xmlpp::DtdValidator::get_dtd | ( |  | ) | const
| noexcept

Get the parsed DTD.

Returns
  A pointer to the parsed DTD, or `nullptr`.

LIBXMLPP_API void xmlpp::DtdValidator::initialize_context | ( |  | ) |
| override protected virtual

Reimplemented from xmlpp::Validator.

LIBXMLPP_API xmlpp::DtdValidator::operator bool | ( |  | ) | const
| explicit override virtual noexcept

Test whether a DTD has been parsed.

For instance

if (validator)
do_something();

Implements xmlpp::Validator.

LIBXMLPP_API void xmlpp::DtdValidator::parse_file | ( | const std::string & | filename | ) |
| override virtual

Parse an external subset (DTD file).

If the validator already contains a DTD, that DTD is deleted.

Parameters

  filename | The URL of the DTD.

Exceptions

  xmlpp::parse_error |

Implements xmlpp::Validator.

LIBXMLPP_API void xmlpp::DtdValidator::parse_memory | ( | const ustring& | contents | ) |
| override virtual

Parse a DTD from a string.

If the validator already contains a DTD, that DTD is deleted.

Parameters

  contents | The DTD as a string.

Exceptions

  xmlpp::parse_error |

Implements xmlpp::Validator.

LIBXMLPP_API void xmlpp::DtdValidator::parse_stream | ( | std::istream & | in | ) |

Parse a DTD from a stream.

If the validator already contains a DTD, that DTD is deleted.

Parameters

  in | The stream.

Exceptions

  xmlpp::parse_error |

LIBXMLPP_API void xmlpp::DtdValidator::parse_subset | ( | const ustring& | external,
|  | const ustring& | system
| ) |  |

Parse an external subset (DTD file).

If the validator already contains a DTD, that DTD is deleted.

Parameters

  external | The external ID of the DTD.
  system | The URL of the DTD.

Exceptions

  xmlpp::parse_error |

LIBXMLPP_API void xmlpp::DtdValidator::release_underlying | ( |  | ) |
| override protected virtual

Reimplemented from xmlpp::Validator.

LIBXMLPP_API void xmlpp::DtdValidator::set_dtd | ( | Dtd* | dtd,
|  | bool | take_ownership
| ) |  |

Set a DTD.

If the validator already contains a DTD, that DTD is released (deleted if the validator owns the DTD).

Parameters

  dtd | A pointer to the DTD to use when validating XML documents.
  take_ownership | If `true`, the validator takes ownership of the DTD. The caller must not delete it. If `false`, the validator does not take ownership of the DTD. The caller must guarantee that the DTD exists as long as the validator keeps a pointer to it. The caller is responsible for deleting the DTD when it's no longer needed.

LIBXMLPP_API void xmlpp::DtdValidator::validate | ( | const Document* | document | ) |
| override virtual

Validate a document, using a previously parsed DTD.

The internal subset (if present) is de-coupled (i.e. not used), which could give problems if ID or IDREF is present.

Parameters

  document | Pointer to the document.

Exceptions

  xmlpp::internal_error |
  xmlpp::validity_error |

Implements xmlpp::Validator.